﻿using UnityEngine;
using UnityEditor;
using System.Collections;
using System.Linq;
using System.Collections.Generic;

[CustomEditor(typeof(RoadGenerator))]
public class RoadGeneratorEditor : Editor 
{
	private RoadGenerator _target;
	private RoadGenerator Target
	{
		get
		{
			if (_target == null)
				_target = (RoadGenerator) target;
			return _target;
		}
	}
	
	public override void OnInspectorGUI()
	{
		EditorGUILayout.BeginVertical(GUI.skin.box);
			EditorGUILayout.LabelField("RoadGenerator");
			EditorGUILayout.BeginHorizontal();
				EditorGUILayout.LabelField("Road consists out of");
				GUI.enabled = false;
				EditorGUILayout.IntField(Target.points.Count);
				GUI.enabled = true;
				EditorGUILayout.LabelField("points");
			EditorGUILayout.EndHorizontal();
		EditorGUILayout.EndVertical();
		
		EditorGUILayout.Space();
		
		base.DrawDefaultInspector();
		if (GUILayout.Button("Create Road"))
		{
			Road r = Road.CreateFrom(
					Target.GetParametizedPoints(Target.roadDetail), 
					Target.roadLayout,
					Vector3.up, 
					Target.roadMaterial);
			r.transform.position = Target.transform.position;
			r.transform.rotation = Target.transform.rotation;
		}
		
		EditorGUILayout.Space();
		
		if (GUILayout.Button("Add Point"))
			Target.points.Add(Target.points[Target.points.Count - 1] + Target.GetTanget(Target.points.Count - 1, false));
		Target.smoothing = EditorGUILayout.FloatField("Line Smoothing", Target.smoothing);
		
		EditorUtility.SetDirty(target);
	}
	
	public void OnSceneGUI()
	{
		Handles.matrix = Target.transform.localToWorldMatrix;
		for (int i = 0; i < Target.points.Count; i++)
			Target.points[i] = Handles.DoPositionHandle(Target.points[i], Quaternion.identity);
		
		
	}
}